from pysat.formula import CNF

cur_var = 0
background = CNF()
TRUE_lit = 0


def new_var():
    global cur_var
    cur_var += 1
    return cur_var


def TRUE():
    global TRUE_lit
    if TRUE_lit:
        return TRUE_lit
    else:
        TRUE_lit = new_var()
        background.append([TRUE_lit])
        return TRUE_lit


def FALSE():
    return -TRUE()


def AND(a, b, constraints=None):
    if constraints is None:
        constraints = background

    # short cut for FALSE
    if a == FALSE() or b == FALSE():
        return FALSE()

    # short cut for TRUE
    if a == TRUE() and b == TRUE():
        return TRUE()
    else:
        c = new_var()
        # a and b -> c
        constraints.append([-a, -b, c])
        # c -> a
        constraints.append([-c, a])
        # c -> b
        constraints.append([-c, b])
        return c


def OR(a, b, constraint=None):
    return -AND(-a, -b, constraint)


def NOT(a):
    return -a


def Implication(a, b, constraints=None):
    return OR(-a, b, constraints)


def IFF(a, b, constraints=None):
    # we can do something with equality
    return AND(Implication(a, b, constraints), Implication(b, a, constraints), constraints)


def XOR(a, b, constraints=None):
    return NOT(IFF(a, b, constraints))
